/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * ͒PĳUARTpͯ ̧قłB
 *
 * ̧ق͒PĳUARTp̒`ϸۂ܂݂܂BATmega32ȊȎϲ ۰ׂ
 * gpꍇA̧ق͕ύXKvłB߰ĂްڰĂ̧قŕύX
 * ܂B
 *
 * \par pLq:
 *      AVR274 : PĳUART
 *
 * \par 
 * IȺގAxׁ߲A߲אݒAx޲ɂĂ
 * readme.htmlB
 *
 * \author
 *      Atmel Corporation: http://www.atmel.com \n
 *      xEҰ: avr@atmel.com
 *
 * $Name:  $
 * $Revision: 1364 $
 * $RCSfile: single_wire_UART.h,v $
 * $Date: 2007N28 14:13:02 +0100 $  \n
 ******************************************************************************/

#ifndef __UART_H
#define __UART_H

#include "stdint.h"			// ^錾
#include "Common_Define.h"

#define F_CPU 4000000ul

// ްڰĐݒ (WAIT_ONE,PRESCALER):
// ްڰ  1MHz  2MHz  4MHz   8MHz
//   4800 207,1  51,8 103,8 (207,8)
//   9600 103,1 207,1  51,8  103,8
//  19200  s 103,1 207,1   51,8
//  28800  s  s 138,1   34,8
//  38400  s  s 103,1  207,1
// WAIT_ONE~PRESCALER100̎UARTwǑSĂCPU邱ƂɒӂĂB

/* ʐMҰ (WAIT_ONE`͉pLq̎2-1.ɏ]ĕύXȂ΂Ȃ܂B) */
#if F_CPU == 1000000ul
  #define WAIT_ONE			103		//!< 1ޯĎԻِ(̒ľvZɂĂ͉pLqB)
									// PRESCALERlWAIT_ONElɑ΂ĈӐ}lɐݒ肳邱ƂmɂĂB
  #define PRESCALER			1		//!< T/COuݒ(ްڰĐݒɏ]Đݒ肳Ȃ΂Ȃ܂B)
#elif F_CPU == 2000000ul
  #define WAIT_ONE			207
  #define PRESCALER			1
#elif F_CPU == 4000000ul
  #define WAIT_ONE			103		// 38400bps
  #define PRESCALER			1
#endif

#define TRANSMIT_DELAY		20		//!< Jnޯđo犄荞ݏł̎ޯđo܂ł̒xِ
#define RECEIVE_DELAY		0			//!< JnޯČoT/Cn܂łƊ荞݂ł̎ޯĎ擾܂ł̒xِ

#define WAIT_HALF			((WAIT_ONE+1)/2)
#define WAIT_ONEHALF		(WAIT_ONE + WAIT_ONE/2)

#define TIMER_PRESCALER_CONTROL_REGISTER	TCCR1B	//!< UARTpɎgpT/Cɏ]Đڼ޽`ĂB
#if (PRESCALER == 1)
  #define START_UART_TIMER()	(TIMER_PRESCALER_CONTROL_REGISTER |=  (1<<CS10))	// /vJn(̊֘A`͈قȂT/CgpꍇɕύXKvłBްĂQƂĂB)
  #define STOP_UART_TIMER()		(TIMER_PRESCALER_CONTROL_REGISTER &= ~(1<<CS10))	// /v~
#elif (PRESCALER == 8)
  #define START_UART_TIMER()	(TIMER_PRESCALER_CONTROL_REGISTER |=  (1<<CS11))	// /vJn
  #define STOP_UART_TIMER()		(TIMER_PRESCALER_CONTROL_REGISTER &= ~(1<<CS11))	// /v~
#else
  #error PRESCALER must be set to 1 or 8	// PRESCALER1`8ɐݒ肳Ȃ΂Ȃ܂B
#endif

#if ( ((WAIT_ONEHALF-(RECEIVE_DELAY/PRESCALER)) > 255) || ((WAIT_ONE) > 255))
  #error WAIT_ONE is set too high. Try to increase prescaler or use a higher baud rate.
  // WAIT_ONE傫܂BOu傫邩A荂ްڰĂĂB
#endif

#if ( (WAIT_ONE) < (100/PRESCALER))
  #error A too high baud rate is used. Please check the PRESCALER and WAIT_ONE setting.
  // ްڰĂgpĂ܂BPRESCALERWAIT_ONE̐ݒ𒲂ׂĂB
#endif

/*  ϸ */
#define INITIALIZE_UART_PIN()	( SWUART_PORT_REG &= ~ (1 << SWUART_PIN) )	//!< o͐ݒ莞̏o͒l0ɐݒ
#define READ_UART_PIN()			( SWUART_PIN_REG & (1 << SWUART_PIN) )		//!< ݒlǂݍ

/* d(OɏՊgp)pϸ */
#define SET_UART_PIN()			( SWUART_PORT_REG &= ~(1 << SWUART_PIN) )	//!< UART݂Higho͐ݒ
#define CLEAR_UART_PIN()		( SWUART_PORT_REG |= (1 << SWUART_PIN) )	//!< UART݂Lowo͐ݒ

/* / ϸ(޲ˑłB) */
#define CLEAR_UART_TIMER_ON_COMPARE_MATCH()		(TCCR1A |= (1<<WGM10))								//!< T/Cڼ޽rvł̌v(CTC)ݒ
#define SET_UART_TIMER_VALUE(x)					(TCNT1 = (x))										//!< T/Clݒ
#define SET_UART_TIMER_COMPARE_WAIT_ONE()		OCR1A = WAIT_ONE									//!< T/Crl1ޯĎԂɐݒ
#define SET_UART_TIMER_COMPARE_START_TRANSMIT()	OCR1A = (WAIT_ONE - (TRANSMIT_DELAY/PRESCALER))		//!< T/CrlޯđMpɐݒ
#define SET_UART_TIMER_COMPARE_START_RECEIVE()	OCR1A = (WAIT_ONEHALF - (RECEIVE_DELAY/PRESCALER))	//!< T/CrlޯĎMpɐݒ

#define COMPARE_MATCH()							(TIFR1 & (1<<OCF1A))	//!< rv(OCF1A)
#define CLEAR_UART_TIMER()						(TCNT1 = 0x00)			//!< T/Cl(0ݒ)
#define CLEAR_UART_TIMER_INTERRUPT_FLAG()		(TIFR1 = (1<<OCF1A))	//!< rv׸(OCF1A)

/* ڼ޽` */
#define SW_UART_ENABLE_BIT					1	//!< UARTꍇɐݒ(1)
#define SW_UART_BOOT_MODE					2	//!< ް۰ޓ`Ԃ̏ꍇɐݒ(1)

#define SW_UART_TX_BUFFER_FULL				4	//!< ްMɏՕ瑗鏀Ăꍇɐݒ(1)
#define SW_UART_RX_BUFFER_FULL				5	//!< ްMɏՕ擾鏀Ăꍇɐݒ(1)
#define SW_UART_RX_BUFFER_OVERFLOW			6	//!< MɏՕꂽꍇɐݒ(1)Aްr܂B
#define SW_UART_FRAME_ERROR					7	//!< ڰݸތ肪Nꍇɐݒ(1)

/* ׸ ϸ */
#define SET_FLAG(flag_register,flag_bit)	( (flag_register) |= (1 << (flag_bit)) )	//!< ڼ޽׸ނݒ(1)鎞ɂϸۂgp܂B
#define CLEAR_FLAG(flag_register,flag_bit)	( (flag_register) &= ~(1 << (flag_bit)) )	//!< ڼ޽׸ނ(0)鎞ɂϸۂgp܂B
#define READ_FLAG(flag_register,flag_bit)	( (flag_register) & (1 << (flag_bit)) )		//!< ڼ޽׸ނǂގɂϸۂgp܂B

/* SUART֐ */
void SW_UART_Enable (void);									//!< UART
void Timer_SW_UART_Transmit (unsigned char UART_Tx_data);	//!< ޲đM
unsigned char Timer_SW_UART_Receive (void);					//!< ޲ĎM
unsigned char recchar (void);								//!< 1޲ĎM(M܂őҋ@)
void sendchar (unsigned char byte);							//!< 1޲đM(M܂őҋ@)

#endif
